
;CodeVisionAVR C Compiler V1.24.8d Professional
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "RC5.vec"
	.INCLUDE "RC5.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.8d Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : 
;       9 Version : 
;      10 Date    : 24.04.2007
;      11 Author  : F4CG                            
;      12 Company : F4CG                            
;      13 Comments: 
;      14 
;      15 
;      16 Chip type           : ATmega32
;      17 Program type        : Application
;      18 Clock frequency     : 4,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 512
;      22 *****************************************************/
;      23 /*
;      24    rc5dec.c 0.2.0 - Interrupt driven RC5 decoder for Atmel AVR C's.
;      25    Website: http://markh.de/rc5dec/
;      26    Copyright (C) 2003  Mark Haemmerling <rc5@markh.de>
;      27 
;      28    This program is free software; you can redistribute it and/or modify
;      29    it under the terms of the GNU General Public License as published by
;      30    the Free Software Foundation; either version 2 of the License, or
;      31    (at your option) any later version.
;      32 
;      33    This program is distributed in the hope that it will be useful,
;      34    but WITHOUT ANY WARRANTY; without even the implied warranty of
;      35    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;      36    GNU General Public License for more details.
;      37 
;      38    You should have received a copy of the GNU General Public License
;      39    along with this program; if not, write to the Free Software
;      40    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;      41 
;      42    Preconfigured for INT1 (PD3) and Timer/Counter0.
;      43 */
;      44 
;      45 #include <mega32.h>
;      46 #include <io.h>
;      47 #include <m8_128.h>
;      48 #include <stdio.h>
;      49 #include <delay.h>
;      50 
;      51 
;      52 
;      53 // set your clock speed here
;      54 #define XTAL 4000000
;      55 
;      56 // you may have to experiment a little with this
;      57 // in case of heavy disturbance, try values around 60
;      58 // try to use odd values (for symmetrical level detection)
;      59 #define RC5RESAMPLE 41  
;      60 
;      61 // this autoconfigures all timer values:
;      62 #if XTAL < 285000
;      63 #define PRESCALEDIV 1
;      64 #define TIMERCR (1<<CS00)
;      65 #elif XTAL < 2300000
;      66 #define PRESCALEDIV 8
;      67 #define TIMERCR (1<<CS01)
;      68 #elif XTAL < 18000000
;      69 #define PRESCALEDIV 64
;      70 #define TIMERCR (1<<CS01) | (1<<CS00)
;      71 #else
;      72 #define PRESCALEDIV 256
;      73 #define TIMERCR (1<<CS02)
;      74 #endif
;      75 #define RC5TIMERFIRST 0x100-((unsigned char) (XTAL/PRESCALEDIV*0.0008890))
;      76 #define RC5TIMERSECOND 0x100-((unsigned char) (XTAL/PRESCALEDIV*0.0004445))
;      77 #define RC5TIMERCANCEL 0x100-((unsigned char) (XTAL/PRESCALEDIV*0.0008890))
;      78 
;      79 volatile unsigned int rc5_code = 0;
_rc5_code:
	.BYTE 0x2
;      80 volatile unsigned char rc5_first_half;
_rc5_first_half:
	.BYTE 0x1
;      81 
;      82 interrupt [EXT_INT1] void ext_int1_isr(void)
;      83 {

	.CSEG
_ext_int1_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      84  /*	external interrupt handler
;      85 	edge from IR receiver detected.
;      86 	this is assumed to be the middle of a bit.
;      87 */
;      88 	unsigned char i;
;      89 	// resample to filter out spikes
;      90    	if (MCUCR & (1<<ISC10)) {
	ST   -Y,R16
;	i -> R16
	IN   R30,0x35
	SBRS R30,2
	RJMP _0x3
;      91 		// we were waiting for a rising edge, so cancel if we sample low
;      92 		for (i = RC5RESAMPLE; i; i--) if (!(PIND & (1<<PIND3))) return;
	LDI  R16,LOW(41)
_0x5:
	CPI  R16,0
	BREQ _0x6
	SBIC 0x10,3
	RJMP _0x7
	CALL SUBOPT_0x0
	RETI
;      93 	} else {
_0x7:
	SUBI R16,1
	RJMP _0x5
_0x6:
	RJMP _0x8
_0x3:
;      94 		// vice versa...
;      95 		for (i = RC5RESAMPLE; i; i--) if ((PIND & (1<<PIND3))) return;
	LDI  R16,LOW(41)
_0xA:
	CPI  R16,0
	BREQ _0xB
	SBIS 0x10,3
	RJMP _0xC
	CALL SUBOPT_0x0
	RETI
;      96 	}   
_0xC:
	SUBI R16,1
	RJMP _0xA
_0xB:
_0x8:
;      97         TCNT0 = RC5TIMERSECOND; // preset timer to sample (ovf int) at second half (3/4 bit time)
	LDI  R30,LOW(229)
	OUT  0x32,R30
;      98 	rc5_first_half = 0; // next sample will be in the second half
	LDI  R30,LOW(0)
	STS  _rc5_first_half,R30
;      99         TIMSK |=(1<<TOIE0); // enable timer ovf int
	IN   R30,0x39
	ORI  R30,1
	OUT  0x39,R30
;     100 	GICR &=~(1<<INT1); // disable ext int (this handler)  
	IN   R30,0x3B
	ANDI R30,0x7F
	OUT  0x3B,R30
;     101 }
	CALL SUBOPT_0x0
	RETI
;     102 
;     103 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     104 /*	timer overflow handler
;     105 	sample the present level of the interrupt line.
;     106 */	
;     107  {	static unsigned int rc5_shift, rc5_temp;
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30

	.DSEG

	.CSEG
;     108 	static unsigned char rc5_bit = 0, level, first_level = 1;

	.DSEG

	.CSEG
;     109 	unsigned char i = 0, temp;
;     110         PORTB.0^=1;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16
;	temp -> R17
	LDI  R16,0
	LDI  R30,0
	SBIC 0x18,0
	LDI  R30,1
	LDI  R26,LOW(1)
	EOR  R30,R26
	CALL __BSTB1
	IN   R26,0x18
	BLD  R26,0
	OUT  0x18,R26
;     111 	// resample to filter out spikes
;     112 	for (temp = RC5RESAMPLE; temp; temp--) if (PIND & (1<<PIND3)) i++;
	LDI  R17,LOW(41)
_0xF:
	CPI  R17,0
	BREQ _0x10
	SBIC 0x10,3
	SUBI R16,-1
;     113 	level = (i > ((unsigned char) (RC5RESAMPLE/2)));   
	SUBI R17,1
	RJMP _0xF
_0x10:
	MOV  R26,R16
	LDI  R30,LOW(20)
	CALL __GTB12U
	MOV  R9,R30
;     114 
;     115 	if (rc5_first_half == 2) {
	LDS  R26,_rc5_first_half
	CPI  R26,LOW(0x2)
	BRNE _0x12
;     116 		// this is a timeout, cancel operation
;     117 		goto rc5_cancel;
	RJMP _0x13
;     118 	} else if (rc5_first_half == 1) {
_0x12:
	LDS  R26,_rc5_first_half
	CPI  R26,LOW(0x1)
	BRNE _0x15
;     119 		// this sample is taken in the first half of the bit (1/4 bit time)
;     120 		first_level = level; // save current level
	MOV  R10,R9
;     121 		if (level) MCUCR &=~(1<<ISC10); // currently at high level, wait for falling edge
	TST  R9
	BREQ _0x16
	IN   R30,0x35
	ANDI R30,0xFB
	RJMP _0x85
;     122 		else MCUCR |=(1<<ISC10); // currently at low level, wait for rising edge
_0x16:
	IN   R30,0x35
	ORI  R30,4
_0x85:
	OUT  0x35,R30
;     123 		rc5_first_half = 2; // special code, means: next ovf int is a timeout
	LDI  R30,LOW(2)
	STS  _rc5_first_half,R30
;     124 		GICR |=(1<<INT1); // much better: wait for edge ;)
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
;     125 		TCNT0 = RC5TIMERCANCEL; // at timer ovf (in around 1/2 bit time) we should get a timeout
	LDI  R30,LOW(201)
	OUT  0x32,R30
;     126 	} else {
	RJMP _0x18
_0x15:
;     127 		// this sample is taken in the second half of the bit (3/4 bit time)
;     128 		TCNT0 = RC5TIMERFIRST; // next sample at first half (1/4 bit time) of next bit
	LDI  R30,LOW(201)
	OUT  0x32,R30
;     129 		rc5_first_half = 1;
	LDI  R30,LOW(1)
	STS  _rc5_first_half,R30
;     130 		if (first_level != level) {
	CP   R9,R10
	BREQ _0x19
;     131 			// levels differ -> valid manchester encoded bit detected
;     132 			if (!rc5_bit) {
	TST  R8
	BRNE _0x1A
;     133 				// this is the first bit, reset values
;     134 				rc5_temp = 0;
	CLR  R6
	CLR  R7
;     135 				rc5_shift = 0x8000;
	LDI  R30,LOW(32768)
	LDI  R31,HIGH(32768)
	MOVW R4,R30
;     136 			}
;     137 			if (!level) rc5_temp |= rc5_shift; // low level (low-active) so store a '1'
_0x1A:
	TST  R9
	BRNE _0x1B
	__ORWRR 6,7,4,5
;     138 			else if (rc5_bit < 2) goto rc5_cancel; // high level ('0' bit) as startbit -> error
	RJMP _0x1C
_0x1B:
	LDI  R30,LOW(2)
	CP   R8,R30
	BRLO _0x13
;     139 			if (++rc5_bit == 14) {
_0x1C:
	INC  R8
	LDI  R30,LOW(14)
	CP   R30,R8
	BRNE _0x1E
;     140 				// reception complete, stop operation
;     141 				rc5_code = rc5_temp; 
	__PUTWMRN _rc5_code,0,6,7
;     142 				goto rc5_cancel;
	RJMP _0x13
;     143 			}
;     144 			if (rc5_shift == 0x0100) rc5_shift = 0x0020;
_0x1E:
	LDI  R30,LOW(256)
	LDI  R31,HIGH(256)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1F
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	MOVW R4,R30
;     145 			else rc5_shift >>= 1;
	RJMP _0x20
_0x1F:
	LSR  R5
	ROR  R4
;     146 		} else {
_0x20:
	RJMP _0x21
_0x19:
;     147 			// error in manchester stream -> cancel operation 
;     148 			goto rc5_cancel;
	RJMP _0x13
;     149 		}
_0x21:
;     150 	}
_0x18:
;     151 	return;
	CALL SUBOPT_0x1
	RETI
;     152 
;     153 rc5_cancel:
_0x13:
;     154 	MCUCR &=~(1<<ISC10); // falling edge
	IN   R30,0x35
	ANDI R30,0xFB
	OUT  0x35,R30
;     155 	GICR |=(1<<INT1); // ext. int. enabled
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
;     156 	GIFR &=~(1<<INTF1); // clear an eventually set ext. int. flag
	IN   R30,0x3A
	ANDI R30,0x7F
	OUT  0x3A,R30
;     157 	TIMSK &=~(1<<TOIE0); // disable timer int.
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
;     158 	first_level = 1; // as the next ext. int. appears at the falling edge, assume the first level as high
	LDI  R30,LOW(1)
	MOV  R10,R30
;     159 	rc5_bit = 0;
	CLR  R8
;     160 }
	CALL SUBOPT_0x1
	RETI
;     161 
;     162 
;     163 void rc5_init(void){
_rc5_init:
;     164 /*	init for ext. int. and timer.
;     165 	call this once to activate the rc5 decoder.
;     166 */
;     167 	TCCR0 = TIMERCR;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     168 	DDRD &=~(1<<PD3); // pin is input
	CBI  0x11,3
;     169 	PORTD &=~(1<<PD3); // pullup disabled (receiver has defined output)
	CBI  0x12,3
;     170 	TIMSK &=~(1<<TOIE0); // timer ovf disabled. gets enabled by ext. int.
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
;     171 	MCUCR |=(1<<ISC11); // ext. int. activated by falling edge
	IN   R30,0x35
	ORI  R30,8
	OUT  0x35,R30
;     172 	MCUCR &=~(1<<ISC10);
	IN   R30,0x35
	ANDI R30,0xFB
	OUT  0x35,R30
;     173 	GIFR = (1<<INTF1); // clear ext. int. flag
	LDI  R30,LOW(128)
	OUT  0x3A,R30
;     174 	GICR |=(1<<INT1); // enable ext. int.
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
;     175 }
	RET
;     176 
;     177 // External Interrupt 0 service routine
;     178 interrupt [EXT_INT0] void ext_int0_isr(void)
;     179 {
_ext_int0_isr:
;     180 // Place your code here
;     181 
;     182 }
	RETI
;     183 
;     184 
;     185 // Declare your global variables here
;     186 
;     187 void main(void)
;     188 {
_main:
;     189 // Declare your local variables here
;     190 char rc5_command,rc5_system;
;     191 // Input/Output Ports initialization
;     192 // Port A initialization
;     193 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     194 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     195 PORTA=0x00;
;	rc5_command -> R16
;	rc5_system -> R17
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     196 DDRA=0x00;
	OUT  0x1A,R30
;     197 
;     198 // Port B initialization
;     199 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     200 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     201 PORTB=0x00;
	OUT  0x18,R30
;     202 DDRB=0x01;
	LDI  R30,LOW(1)
	OUT  0x17,R30
;     203 // Port C initialization
;     204 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     205 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     206 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     207 DDRC=0x00;
	OUT  0x14,R30
;     208 
;     209 // Port D initialization
;     210 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     211 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     212 PORTD=0x00;
	OUT  0x12,R30
;     213 DDRD=0x00;
	OUT  0x11,R30
;     214 
;     215 // Timer/Counter 0 initialization
;     216 // Clock source: System Clock
;     217 // Clock value: Timer 0 Stopped
;     218 // Mode: Normal top=FFh
;     219 // OC0 output: Disconnected
;     220 TCCR0=0x00;
	OUT  0x33,R30
;     221 TCNT0=0x00;
	OUT  0x32,R30
;     222 OCR0=0x00;
	OUT  0x3C,R30
;     223 
;     224 // Timer/Counter 1 initialization
;     225 // Clock source: System Clock
;     226 // Clock value: Timer 1 Stopped
;     227 // Mode: Normal top=FFFFh
;     228 // OC1A output: Discon.
;     229 // OC1B output: Discon.
;     230 // Noise Canceler: Off
;     231 // Input Capture on Falling Edge
;     232 // Timer 1 Overflow Interrupt: Off
;     233 // Input Capture Interrupt: Off
;     234 // Compare A Match Interrupt: Off
;     235 // Compare B Match Interrupt: Off
;     236 TCCR1A=0x00;
	OUT  0x2F,R30
;     237 TCCR1B=0x00;
	OUT  0x2E,R30
;     238 TCNT1H=0x00;
	OUT  0x2D,R30
;     239 TCNT1L=0x00;
	OUT  0x2C,R30
;     240 ICR1H=0x00;
	OUT  0x27,R30
;     241 ICR1L=0x00;
	OUT  0x26,R30
;     242 OCR1AH=0x00;
	OUT  0x2B,R30
;     243 OCR1AL=0x00;
	OUT  0x2A,R30
;     244 OCR1BH=0x00;
	OUT  0x29,R30
;     245 OCR1BL=0x00;
	OUT  0x28,R30
;     246 
;     247 // Timer/Counter 2 initialization
;     248 // Clock source: System Clock
;     249 // Clock value: Timer 2 Stopped
;     250 // Mode: Normal top=FFh
;     251 // OC2 output: Disconnected
;     252 ASSR=0x00;
	OUT  0x22,R30
;     253 TCCR2=0x00;
	OUT  0x25,R30
;     254 TCNT2=0x00;
	OUT  0x24,R30
;     255 OCR2=0x00;
	OUT  0x23,R30
;     256 
;     257 // External Interrupt(s) initialization
;     258 // INT0: On
;     259 // INT0 Mode: Low level
;     260 // INT1: Off
;     261 // INT2: Off
;     262 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     263 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     264 MCUCSR=0x00;
	OUT  0x34,R30
;     265 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     266 
;     267 
;     268 // USART initialization
;     269 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     270 // USART Receiver: Off
;     271 // USART Transmitter: On
;     272 // USART Mode: Asynchronous
;     273 // USART Baud rate: 19200
;     274 UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     275 UCSRB=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
;     276 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     277 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     278 UBRRL=0x0C;
	LDI  R30,LOW(12)
	OUT  0x9,R30
;     279 
;     280 // Timer(s)/Counter(s) Interrupt(s) initialization
;     281 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     282 
;     283 // Analog Comparator initialization
;     284 // Analog Comparator: Off
;     285 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     286 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     287 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     288 
;     289 // Global enable interrupts
;     290 #asm("sei");
	sei
;     291 rc5_init(); 
	CALL _rc5_init
;     292 while (1) {
_0x22:
;     293       if (rc5_code) {
	LDS  R30,_rc5_code
	LDS  R31,_rc5_code+1
	SBIW R30,0
	BREQ _0x25
;     294       rc5_command=(unsigned char) rc5_code;
	LDS  R16,_rc5_code
;     295       rc5_system=(unsigned char) (rc5_code>>6);
	LDS  R26,_rc5_code
	LDS  R27,_rc5_code+1
	LDI  R30,LOW(6)
	CALL __LSRW12
	MOV  R17,R30
;     296       rc5_system&=0b00111111;
	ANDI R17,LOW(63)
;     297       printf("System = %i ",rc5_system);
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CALL SUBOPT_0x2
;     298       putsf("\r\n");
;     299       printf("Command = %i ",rc5_command);
	__POINTW1FN _0,16
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CALL SUBOPT_0x2
;     300       putsf("\r\n");
;     301       rc5_code = 0; // clear code
	LDI  R30,0
	STS  _rc5_code,R30
	STS  _rc5_code+1,R30
;     302       rc5_command = 0;
	LDI  R16,LOW(0)
;     303       delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     304      };	
_0x25:
;     305 	
;     306 }
	RJMP _0x22
;     307 }
_0x26:
	RJMP _0x26

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x27
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x28
_0x27:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x28:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x29:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2B
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x2F
	CPI  R19,37
	BRNE _0x30
	LDI  R16,LOW(1)
	RJMP _0x31
_0x30:
	RCALL SUBOPT_0x3
_0x31:
	RJMP _0x2E
_0x2F:
	CPI  R30,LOW(0x1)
	BRNE _0x32
	CPI  R19,37
	BRNE _0x33
	RCALL SUBOPT_0x3
	RJMP _0x86
_0x33:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x34
	LDI  R17,LOW(1)
	RJMP _0x2E
_0x34:
	CPI  R19,43
	BRNE _0x35
	LDI  R21,LOW(43)
	RJMP _0x2E
_0x35:
	CPI  R19,32
	BRNE _0x36
	LDI  R21,LOW(32)
	RJMP _0x2E
_0x36:
	RJMP _0x37
_0x32:
	CPI  R30,LOW(0x2)
	BRNE _0x38
_0x37:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x39
	ORI  R17,LOW(128)
	RJMP _0x2E
_0x39:
	RJMP _0x3A
_0x38:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x2E
_0x3A:
	CPI  R19,48
	BRLO _0x3D
	CPI  R19,58
	BRLO _0x3E
_0x3D:
	RJMP _0x3C
_0x3E:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2E
_0x3C:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x42
	RCALL SUBOPT_0x4
	LD   R30,X
	RCALL SUBOPT_0x5
	RJMP _0x43
_0x42:
	CPI  R30,LOW(0x73)
	BRNE _0x45
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	CALL _strlen
	MOV  R16,R30
	RJMP _0x46
_0x45:
	CPI  R30,LOW(0x70)
	BRNE _0x48
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x46:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x49
_0x48:
	CPI  R30,LOW(0x64)
	BREQ _0x4C
	CPI  R30,LOW(0x69)
	BRNE _0x4D
_0x4C:
	ORI  R17,LOW(4)
	RJMP _0x4E
_0x4D:
	CPI  R30,LOW(0x75)
	BRNE _0x4F
_0x4E:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x58)
	BRNE _0x52
	ORI  R17,LOW(8)
	RJMP _0x53
_0x52:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x84
_0x53:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x50:
	SBRS R17,2
	RJMP _0x55
	RCALL SUBOPT_0x4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x56
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x56:
	CPI  R21,0
	BREQ _0x57
	SUBI R16,-LOW(1)
	RJMP _0x58
_0x57:
	ANDI R17,LOW(251)
_0x58:
	RJMP _0x59
_0x55:
	RCALL SUBOPT_0x4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x59:
_0x49:
	SBRC R17,0
	RJMP _0x5A
_0x5B:
	CP   R16,R20
	BRSH _0x5D
	SBRS R17,7
	RJMP _0x5E
	SBRS R17,2
	RJMP _0x5F
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x60
_0x5F:
	LDI  R19,LOW(48)
_0x60:
	RJMP _0x61
_0x5E:
	LDI  R19,LOW(32)
_0x61:
	RCALL SUBOPT_0x3
	SUBI R20,LOW(1)
	RJMP _0x5B
_0x5D:
_0x5A:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x62
_0x63:
	CPI  R18,0
	BREQ _0x65
	SBRS R17,3
	RJMP _0x66
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x87
_0x66:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x87:
	ST   -Y,R30
	RCALL SUBOPT_0x7
	CPI  R20,0
	BREQ _0x68
	SUBI R20,LOW(1)
_0x68:
	SUBI R18,LOW(1)
	RJMP _0x63
_0x65:
	RJMP _0x69
_0x62:
_0x6B:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x6D:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x6F
	SUBI R19,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x6D
_0x6F:
	CPI  R19,58
	BRLO _0x70
	SBRS R17,3
	RJMP _0x71
	SUBI R19,-LOW(7)
	RJMP _0x72
_0x71:
	SUBI R19,-LOW(39)
_0x72:
_0x70:
	SBRC R17,4
	RJMP _0x74
	CPI  R19,49
	BRSH _0x76
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x75
_0x76:
	RJMP _0x88
_0x75:
	CP   R20,R18
	BRLO _0x7A
	SBRS R17,0
	RJMP _0x7B
_0x7A:
	RJMP _0x79
_0x7B:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x7C
	LDI  R19,LOW(48)
_0x88:
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0x7D
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x7
	CPI  R20,0
	BREQ _0x7E
	SUBI R20,LOW(1)
_0x7E:
_0x7D:
_0x7C:
_0x74:
	RCALL SUBOPT_0x3
	CPI  R20,0
	BREQ _0x7F
	SUBI R20,LOW(1)
_0x7F:
_0x79:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x6C
	RJMP _0x6B
_0x6C:
_0x69:
	SBRS R17,0
	RJMP _0x80
_0x81:
	CPI  R20,0
	BREQ _0x83
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x5
	RJMP _0x81
_0x83:
_0x80:
_0x84:
_0x43:
_0x86:
	LDI  R16,LOW(0)
_0x2E:
	RJMP _0x29
_0x2B:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LD   R16,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
	__POINTW1FN _0,13
	ST   -Y,R31
	ST   -Y,R30
	JMP  _putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

_putsf:
	ld   r30,y+
	ld   r31,y+
__putsf0:
	lpm  r0,z+
	tst  r0
	breq __putsf1
	push r30
	push r31
	rcall __putsf2
	pop  r31
	pop  r30
	rjmp __putsf0
__putsf1:
	ldi  r22,10
	mov  r0,r22
__putsf2:
	st   -y,r0
	jmp _putchar

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__BSTB1:
	CLT
	CLR  R0
	CPSE R30,R0
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
